put_bucket_policy¶
Operation¶
put_bucket_policy
async
¶
put_bucket_policy(request: PutBucketPolicyInput | PutBucketPolicyInputDict, /, *, plugins: list[Plugin] | None = None) -> PutBucketPolicyOutput
put_bucket_policy(*, plugins: list[Plugin] | None = None, **kwargs: Unpack[PutBucketPolicyInputDict]) -> PutBucketPolicyOutput
Applies an Amazon S3 bucket policy to an Amazon S3 bucket.
Note
Directory buckets - For directory buckets, you must make requests
for this API operation to the Regional endpoint. These endpoints support
path-style requests in the format
https://s3express-control.region-code.amazonaws.com/bucket-name.
Virtual-hosted-style requests aren't supported. For more information
about endpoints in Availability Zones, see Regional and Zonal endpoints
for directory buckets in Availability
Zones
in the Amazon S3 User Guide. For more information about endpoints in
Local Zones, see Concepts for directory buckets in Local
Zones
in the Amazon S3 User Guide.
- Permissions
-
If you are using an identity other than the root user of the Amazon Web Services account that owns the bucket, the calling identity must both have the
PutBucketPolicypermissions on the specified bucket and belong to the bucket owner's account in order to use this operation.If you don't have
PutBucketPolicypermissions, Amazon S3 returns a403 Access Deniederror. If you have the correct permissions, but you're not using an identity that belongs to the bucket owner's account, Amazon S3 returns a405 Method Not Allowederror.Warning: To ensure that bucket owners don't inadvertently lock themselves out of their own buckets, the root principal in a bucket owner's Amazon Web Services account can perform the
GetBucketPolicy,PutBucketPolicy, andDeleteBucketPolicyAPI actions, even if their bucket policy explicitly denies the root principal's access. Bucket owner root principals can only be blocked from performing these API actions by VPC endpoint policies and Amazon Web Services Organizations policies. - General purpose bucket permissions - Thes3:PutBucketPolicypermission is required in a policy. For more information about general purpose buckets bucket policies, see Using Bucket Policies and User Policies in the Amazon S3 User Guide.- Directory bucket permissions - To grant access to this API
operation, you must have the
s3express:PutBucketPolicypermission in an IAM identity-based policy instead of a bucket policy. Cross-account access to this API operation isn't supported. This operation can only be performed by the Amazon Web Services account that owns the resource. For more information about directory bucket policies and permissions, see Amazon Web Services Identity and Access Management (IAM) for S3 Express One Zone in the Amazon S3 User Guide.
- Directory bucket permissions - To grant access to this API
operation, you must have the
- Example bucket policies
-
General purpose buckets example bucket policies - See Bucket policy examples in the Amazon S3 User Guide.
Directory bucket example bucket policies - See Example bucket policies for S3 Express One Zone in the Amazon S3 User Guide.
- HTTP Host header syntax
-
Directory buckets - The HTTP Host header syntax is
s3express-control.region-code.amazonaws.com.
The following operations are related to PutBucketPolicy:
Warning
You must URL encode any signed header values that contain spaces. For
example, if your header value is my file.txt, containing two spaces
after my, you must URL encode this value to my%20%20file.txt.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
plugins
|
list[Plugin] | None
|
A list of callables that modify the configuration dynamically. Changes made by these plugins only apply for the duration of the operation execution and will not affect any other operation invocations. |
None
|
Returns:
| Type | Description |
|---|---|
PutBucketPolicyOutput
|
An instance of |
Input¶
Pass the input fields as keyword arguments, or pass a model or dictionary as the first positional argument. Pass plugins separately as a keyword argument.
Model¶
PutBucketPolicyInput
dataclass
¶
Bases: _SerdeShape
Dataclass for PutBucketPolicyInput structure.
Attributes¶
bucket
class-attribute
instance-attribute
¶
bucket: str | None = ...
The name of the bucket.
Directory buckets - When you use this operation with a directory
bucket, you must use path-style requests in the format
https://s3express-control.region-code.amazonaws.com/bucket-name.
Virtual-hosted-style requests aren't supported. Directory bucket names
must be unique in the chosen Zone (Availability Zone or Local Zone).
Bucket names must also follow the format
bucket-base-name--zone-id--x-s3 (for example,
DOC-EXAMPLE-BUCKET--usw2-az1--x-s3). For information
about bucket naming restrictions, see Directory bucket naming
rules
in the Amazon S3 User Guide
checksum_algorithm
class-attribute
instance-attribute
¶
checksum_algorithm: str | None = ...
Indicates the algorithm used to create the checksum for the request when
you use the SDK. This header will not provide any additional
functionality if you don't use the SDK. When you send this header,
there must be a corresponding x-amz-checksum-algorithm or
x-amz-trailer header sent. Otherwise, Amazon S3 fails the request with
the HTTP status code 400 Bad Request.
For the x-amz-checksum-algorithm header, replace
algorithm with the supported algorithm from the following
list:
-
CRC32 -
CRC32C -
CRC64NVME -
MD5 -
SHA1 -
SHA256 -
SHA512 -
XXHASH3 -
XXHASH64 -
XXHASH128
For more information, see Checking object integrity in the Amazon S3 User Guide.
If the individual checksum value you provide through
x-amz-checksum-algorithm doesn't match the checksum algorithm
you set through x-amz-sdk-checksum-algorithm, Amazon S3 fails the
request with a BadDigest error.
Note
For directory buckets, when you use Amazon Web Services SDKs, CRC32 is
the default checksum algorithm that's used for performance.
confirm_remove_self_bucket_access
class-attribute
instance-attribute
¶
confirm_remove_self_bucket_access: bool | None = ...
Set this parameter to true to confirm that you want to remove your permissions to change this bucket policy in the future.
Note
This functionality is not supported for directory buckets.
content_md5
class-attribute
instance-attribute
¶
content_md5: str | None = ...
The MD5 hash of the request body.
For requests made using the Amazon Web Services Command Line Interface (CLI) or Amazon Web Services SDKs, this field is calculated automatically.
Note
This functionality is not supported for directory buckets.
expected_bucket_owner
class-attribute
instance-attribute
¶
expected_bucket_owner: str | None = ...
The account ID of the expected bucket owner. If the account ID that you
provide does not match the actual owner of the bucket, the request fails
with the HTTP status code 403 Forbidden (access denied).
Note
For directory buckets, this header is not supported in this API
operation. If you specify this header, the request fails with the HTTP
status code 501 Not Implemented.
Dictionaries¶
PutBucketPolicyInputDict
¶
Bases: TypedDict
Dictionary form of PutBucketPolicyInput.
Attributes¶
bucket
instance-attribute
¶
The name of the bucket.
Directory buckets - When you use this operation with a directory
bucket, you must use path-style requests in the format
https://s3express-control.region-code.amazonaws.com/bucket-name.
Virtual-hosted-style requests aren't supported. Directory bucket names
must be unique in the chosen Zone (Availability Zone or Local Zone).
Bucket names must also follow the format
bucket-base-name--zone-id--x-s3 (for example,
DOC-EXAMPLE-BUCKET--usw2-az1--x-s3). For information
about bucket naming restrictions, see Directory bucket naming
rules
in the Amazon S3 User Guide
checksum_algorithm
instance-attribute
¶
checksum_algorithm: str | None
Indicates the algorithm used to create the checksum for the request when
you use the SDK. This header will not provide any additional
functionality if you don't use the SDK. When you send this header,
there must be a corresponding x-amz-checksum-algorithm or
x-amz-trailer header sent. Otherwise, Amazon S3 fails the request with
the HTTP status code 400 Bad Request.
For the x-amz-checksum-algorithm header, replace
algorithm with the supported algorithm from the following
list:
-
CRC32 -
CRC32C -
CRC64NVME -
MD5 -
SHA1 -
SHA256 -
SHA512 -
XXHASH3 -
XXHASH64 -
XXHASH128
For more information, see Checking object integrity in the Amazon S3 User Guide.
If the individual checksum value you provide through
x-amz-checksum-algorithm doesn't match the checksum algorithm
you set through x-amz-sdk-checksum-algorithm, Amazon S3 fails the
request with a BadDigest error.
Note
For directory buckets, when you use Amazon Web Services SDKs, CRC32 is
the default checksum algorithm that's used for performance.
confirm_remove_self_bucket_access
instance-attribute
¶
confirm_remove_self_bucket_access: bool | None
Set this parameter to true to confirm that you want to remove your permissions to change this bucket policy in the future.
Note
This functionality is not supported for directory buckets.
content_md5
instance-attribute
¶
content_md5: str | None
The MD5 hash of the request body.
For requests made using the Amazon Web Services Command Line Interface (CLI) or Amazon Web Services SDKs, this field is calculated automatically.
Note
This functionality is not supported for directory buckets.
expected_bucket_owner
instance-attribute
¶
expected_bucket_owner: str | None
The account ID of the expected bucket owner. If the account ID that you
provide does not match the actual owner of the bucket, the request fails
with the HTTP status code 403 Forbidden (access denied).
Note
For directory buckets, this header is not supported in this API
operation. If you specify this header, the request fails with the HTTP
status code 501 Not Implemented.
Output¶
PutBucketPolicyOutput
dataclass
¶
Bases: _SerdeShape
Dataclass for PutBucketPolicyOutput structure.